
/* Chrysalide - Outil d'analyse de fichiers binaires
 * gtkbufferview.h - prototypes pour l'affichage de tampons de lignes
 *
 * Copyright (C) 2010-2013 Cyrille Bagard
 *
 *  This file is part of Chrysalide.
 *
 *  Chrysalide is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Chrysalide is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with Foobar.  If not, see <http://www.gnu.org/licenses/>.
 */


#ifndef _GTK_BUFFERVIEW_INT_H
#define _GTK_BUFFERVIEW_INT_H


#include "gtkbufferview.h"


#include "gtkviewpanel-int.h"



/* Réagit à un déplacement de curseur. */
typedef bool (* notify_caret_relocation_fc) (GtkBufferView *, const GdkRectangle *, const vmpa2t *);


/* Composant d'affichage de tampon de lignes (instance) */
struct _GtkBufferView
{
    GtkViewPanel parent;                    /* A laisser en premier        */

    //GCodeBuffer *buffer;                    /* Code sous forme de texte    */
    GBufferView *buffer_view;               /* Affichage de cette forme    */

    gint line_height;                       /* Hauteur maximale des lignes */
    gint left_margin;                       /* Marge gauche + espace       */
    gint left_text;                         /* Début d'impression du code  */

    GdkRectangle caret;                     /* Emplacement du curseur      */
    const vmpa2t *caret_addr;               /* Position mémoire du curseur */   /* FIXME : REMME */
    guint caret_timer;                      /* Identifiant du chronomètre  */
    bool show_caret;                        /* Bascule entre les affichages*/

};

/* Composant d'affichage de tampon de lignes (classe) */
struct _GtkBufferViewClass
{
    GtkViewPanelClass parent;               /* A laisser en premier        */

    notify_caret_relocation_fc notify_caret;/* Accompagne un déplacement   */

    /* Signaux */

    void (* reach_limit) (GtkBufferView *, GdkScrollDirection);

};



#endif  /* _GTK_BUFFERVIEW_INT_H */
